import React, { Component } from "react";
import ReactDOM from "react-dom";

import Container3d from "react-container-3d";
import CubeView from "react-cubeview";
import "../node_modules/react-cubeview/lib/css/react-cubeview.css";
import './App.css'
import * as THREE from "three";
let OrbitControls = require("react-cubeview/lib/OrbitControls")(THREE)

var cube, controls
window.three = THREE

var raycaster = new THREE.Raycaster();
var mouse = new THREE.Vector2();

export default class App extends Component {
  constructor(props){
    super(props);

    this.updateAngles = this.updateAngles.bind(this);
    this.getMainCanvas = this.getMainCanvas.bind(this);
    window.addEventListener( 'mousedown', this.onMouseDown, false )
    
  }
  //will return the main container (canvas)
  getMainCanvas() {
    var mainCanvas = ReactDOM.findDOMNode(window.mainContainer);
    return mainCanvas;
  }

  //will update the camera angles/position from the orbitcontrols on the c3d
  updateAngles(phi, theta) {
    window.mainContainer.setAngles(phi, theta);
  }

  //called when the scene is created
  Setup(scene, camera, renderer) {
    //add cool 3d objects here ~ remember to import THREE
    // var geometry = new THREE.PlaneGeometry(1,2);
    // var material = new THREE.MeshBasicMaterial( {color: 'green', side: THREE.DoubleSide} );
    camera.position.set(0,1,5)
    controls = new OrbitControls(camera, document.getElementById("container3dViewer"), this.updateAngles2)
    // var mesh = new THREE.Mesh(geometry, material);
    // scene.add(mesh);
  }

  onMouseDown( event ) {

    // calculate mouse position in normalized device coordinates
    // (-1 to +1) for both components
  
    mouse.x = ( event.clientX / window.innerWidth ) * 2 - 1;
    mouse.y = - ( event.clientY / window.innerHeight ) * 2 + 1;
    raycaster.setFromCamera( mouse, window.mainContainer.getCamera() );
    // calculate objects intersecting the picking ray
    var intersects = raycaster.intersectObjects( window.mainContainer.getScene().children );
     
  }

  //called every frame
  Update(scene, camera, renderer) {
    renderer.render(scene,camera)
    //animate things
  }

  updateAngles = (phi, theta) => {
    if (controls)
        controls.setPolarAngle(phi);
    controls && controls.setAzimuthalAngle(theta)
  };

  updateAngles2 = (phi, theta) => {
      if (cube) {
          cube.setAngles(phi, theta);
      }
  }

  render() {
    return (
      <div className="canvas">
         <div className="canvas-3d">
          <Container3d
              percentageWidth={'100%'}
              fitScreen
              ref={c => (window.mainContainer = c)}
              marginBottom={30}
              addLight={false}
              addControls={true}
              addGrid={true}
              antialias={false}
              onUpdateAngles={this.updateAngles2}
              onHoverStart={this.onHoverStart}
              onHoverEnd={this.onHoverEnd}
              setup={this.Setup}
              update={this.Update}
          />
         </div>
         

        <div className="cube-view">
          <CubeView
              aspect={1}
              hoverColor={0x0088ff}
              cubeSize={2}
              ref={c => (cube = c)}
              zoom={6}
              antialias={false}
              key={'cv'}
              width={150}
              height={150}
              onUpdateAngles={this.updateAngles}
              relatedCanvas={this.getMainCanvas}
          />
        </div>
      </div>
    );
  }
}
